<script>
/* global PagefindUI:readonly */
import { getSiteVersion } from "../../services/versions";
import { getSearchParamsFromURL } from "../../search/utils";

export default {
  data() {
    return {
      pagefind: null,
      error: false,
    };
  },
  computed: {
    version() {
      return getSiteVersion();
    },
  },
  async mounted() {
    const { qParam } = getSearchParamsFromURL();
    this.query = qParam;
    await this.initPagefind();
  },
  methods: {
    async initPagefind() {
      try {
        this.pagefind = new PagefindUI({
          element: "#search-container",
          baseUrl: `/${getSiteVersion()}/`,
          bundlePath: `/${getSiteVersion()}/pagefind/`,
          showImages: false,
          showEmptyFilters: false,
          resetStyles: false,
          debounceTimeoutMs: 500,
          ranking: {
            termSaturation: 2.0,
          },
          onResults: () => {
            // Clear any previous error messages on successful search
            this.error = false;
          },
          onError: (error) => {
            this.error = true;
            console.error("PagefindUI error:", error);
          },
        });
        this.pagefind.triggerSearch(this.query);
      } catch (error) {
        this.error = true;
        console.error("Error initializing PagefindUI:", error);
      }
    },
    handleInput(event) {
      // Prevent the default behavior of the PageFind UI
      event.preventDefault();
      // Logic to set the query param to new search
      const searchQuery = event.target.value;
      const url = new window.URL(document.location);
      url.searchParams.set("q", searchQuery);
      window.history.replaceState({}, "", url);
    },
  },
};
</script>

<template>
  <div class="pagefind-search gl-mb-9">
    <h1 class="gl-mb-6" data-testid="version-header">
      Search the {{ version }} docs
    </h1>
    <div id="search-container" type="text" @input="handleInput"></div>
    <p v-if="error" class="gl-py-5" data-testid="pagefind-error">
      Error fetching search index.
    </p>
  </div>
</template>
